glibmm: Gio::PollableOutputStream Class Reference

glibmm 2.38.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::PollableOutputStream Class Reference

PollableOutputStream - Interface for pollable output streams. More...

`#include <giomm/pollableoutputstream.h>`

Inheritance diagram for Gio::PollableOutputStream:
[legend]

## Public Member Functions
virtual | ~PollableOutputStream ()
GPollableOutputStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GPollableOutputStream* | gobj () const
| Provides access to the underlying C GObject. More...
bool | can_poll () const
| Checks if stream is actually pollable. More...
bool | is_writable () const
| Checks if stream can be written. More...
gssize | write_nonblocking (const void* buffer, gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Attempts to write up to count bytes from buffer to stream, as with g_output_stream_write(). More...
gssize | write_nonblocking (const void* buffer, gsize count)
| A write_nonblocking() convenience overload. More...
virtual bool | can_poll_vfunc () const
virtual bool | is_writable_vfunc () const
virtual gssize | write_nonblocking_vfunc (const void* buffer, gsize count)
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
virtual | ~Interface ()
GObject* | gobj ()
const GObject* | gobj () const
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| PollableOutputStream ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gio::PollableOutputStream > | wrap (GPollableOutputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

PollableOutputStream - Interface for pollable output streams.

PollableOutputStream is implemented by OutputStreams that can be polled for readiness to write. This can be used when interfacing with a non-GIO API that expects UNIX-file-descriptor-style asynchronous I/O rather than GIO-style.

Since glibmm 2.34:

## Constructor & Destructor Documentation

Gio::PollableOutputStream::PollableOutputStream | ( |  | ) |
| protected

You should derive from this class to use it.

virtual Gio::PollableOutputStream::~PollableOutputStream | ( |  | ) |
| virtual

## Member Function Documentation

static void Gio::PollableOutputStream::add_interface | ( | GType | gtype_implementer | ) |
| static

bool Gio::PollableOutputStream::can_poll | ( |  | ) | const

Checks if stream is actually pollable.

Some classes may implement PollableOutputStream but have only certain instances of that class be pollable. If this method returns `false`, then the behavior of other PollableOutputStream methods is undefined.

For any given stream, the value returned by this method is constant; a stream cannot switch from pollable to non-pollable or vice versa.

Since glibmm 2.28:

Returns
  `true` if stream is pollable, `false` if not.

virtual bool Gio::PollableOutputStream::can_poll_vfunc | ( |  | ) | const
| virtual

static GType Gio::PollableOutputStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GPollableOutputStream* Gio::PollableOutputStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GPollableOutputStream* Gio::PollableOutputStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

bool Gio::PollableOutputStream::is_writable | ( |  | ) | const

Checks if stream can be written.

Note that some stream types may not be able to implement this 100% reliably, and it is possible that a call to g_output_stream_write() after this returns `true` would still block. To guarantee non-blocking behavior, you should always use g_pollable_output_stream_write_nonblocking(), which will return a IO_ERROR_WOULD_BLOCK error rather than blocking.

Since glibmm 2.28:

Returns
  `true` if stream is writable, `false` if not. If an error has occurred on stream, this will result in g_pollable_output_stream_is_writable() returning `true`, and the next attempt to write will return the error.

virtual bool Gio::PollableOutputStream::is_writable_vfunc | ( |  | ) | const
| virtual

gssize Gio::PollableOutputStream::write_nonblocking | ( | const void * | buffer,
|  | gsize | count,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Attempts to write up to count bytes from buffer to stream, as with g_output_stream_write().

If stream is not currently writable, this will immediately return IO_ERROR_WOULD_BLOCK, and you can use g_pollable_output_stream_create_source() to create a Source that will be triggered when stream is writable.

Note that since this method never blocks, you cannot actually use cancellable to cancel it. However, it will return an error if cancellable has already been cancelled when you call, which may happen if you call this method after a source triggers due to having been cancelled.

Virtual: write_nonblocking

Parameters

  buffer | A buffer to write data from.
  count | The number of bytes you want to write.
  cancellable | A Cancellable, or `0`.

Returns
  The number of bytes written, or -1 on error (including IO_ERROR_WOULD_BLOCK).

gssize Gio::PollableOutputStream::write_nonblocking | ( | const void * | buffer,
|  | gsize | count
| ) |  |

A write_nonblocking() convenience overload.

virtual gssize Gio::PollableOutputStream::write_nonblocking_vfunc | ( | const void * | buffer,
|  | gsize | count
| ) |  |
| virtual

Exceptions

  Glib::Error. |

## Friends And Related Function Documentation

Glib::RefPtr< Gio::PollableOutputStream > wrap | ( | GPollableOutputStream * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.